#!/usr/bin/perl 
#
# $Id: monitor.cgi,v 1.1.2.3 2006/03/20 10:03:24 anton Exp $

$url="monitor.cgi";

require "netams.cgi";

$access=CheckAccess("MONITOR");
if($access<1 or
  ($access<2 and ($action ne "list" and $action ne ""))) {
        NoAccess();
}

%type,%name,%ip,%mask,%password,%email,%parent;
	

	$toppane = "<b>$L_monitor</b>";

	if ($cgi->param("period") ne "" and $cgi->param("detail") ne "") {
		$ref = "$url?oid=$oid&period=".$cgi->param("period")."&detail=".$cgi->param("detail");
		$p1 = "<b>$L_monitor_permanentref:</b> <A href=\"$ref\">$ref</a><br><br>"; 

		use DBI;
    	$dbh = DBI->connect("DBI:mysql:database=$mysql_dbname;host=$mysql_host", $mysql_login, $mysql_password);
        if ($dbh eq "") {$p1.="<b>Unable to connect to SQL database!</b><hr>"; }
		else {

			if ($oid!=0) {$select_oids="and unit_oid=0x$oid"; } else {$select_oids=""};
			$period = $cgi->param("period");
			if ($period eq "month") { $t=time() - 30*24*60*60; } 
			elsif ($period eq "week") { $t=time() - 7*24*60*60; } 
			elsif ($period eq "day") { $t=time() - 24*60*60; } 
			elsif ($period eq "hour") { $t=time() - 60*60; } 
			else { $t=0; } 

			$p2 = "<table width=100% cellpadding=2 cellspacing=0 border=1>";

			if ($cgi->param("detail") eq "list") {
				$p2 .="<tr bgcolor='#cccccc'><td>SITE</td><td>COUNT</td><td>SIZE</td><td>LAST VIEWED</td></tr>\n";
				$sth = $dbh->prepare("select left(layer7,locate('/',layer7)-1), count(*), sum(len), from_unixtime(max(time)) from monitor where locate('/', layer7)>0 and time>$t $select_oids group by 1 order by 2 desc limit 100;");
				$sth->execute();
				while ( ($site,$count,$size,$last) = $sth->fetchrow_array) {
					$p2 .="<tr><td>$site</td><td>$count</td><td>$size</td><td>$last</td></tr>\n";
					}
			} elsif ($cgi->param("detail") eq "urls") {
				$p2 .="<tr bgcolor='#cccccc'><td>URL</td><td>SIZE</td><td>VIEWED</td></tr>\n";
				$sth = $dbh->prepare("select layer7, len, from_unixtime(time) from monitor where time>$t $select_oids order by time desc limit 250;");
				$sth->execute();
				while ( ($site,$size,$last) = $sth->fetchrow_array) {
					$p2 .="<tr><td><a href=\"http://$site\">$site</td><td>$size</td><td>$last</td></tr>\n";
					}
			}
			$p2.= "</table>";
			$dbh->disconnect;
		} 
	} else {

		getUnits();
		
		$p1.="<b>$L_monitor_unitselect:</b><br>\n";
		if ($oid!=0) { $p1.="$L_monitor_currentunit: $name{$oid} ($oid)<input type=hidden name=oid value=$oid><br>\n";}
		$p1.="<br><a href=\"$url?oid=000000\">$L_monitor_allunits</a> (000000)<br>\n";
		$p1.="<br><table width=100% cellpadding=2 cellspacing=0 border=1>";
		$k=0;
		foreach $id (keys %type) {
			$k++;
			if($parent{$id} ne "") {
				$parent="<a href='$url?oid=$id'>$parent{$id}</a>";
			} else { $parent="none"; }
			$href="$url?oid=$id";
			if ($id eq $oid) { $hl="bgcolor=yellow"; } else { $hl=""; }
			$p1.="<tr $hl><td><a href=$href>$k</a></td><td bgcolor=#cccccc>$type{$id}</td><td><a href=$href><b>$name{$id}</b> (<font size=-1>$id</font>)</a></td><td>Parent: $parent</td><td bgcolor=#eeeeee>"; 
				
			if ($type{$id} eq 'host' or $type{$id} eq 'user') {
				$p1.= "<b>IP:</b> $ip{$id}";
				#$p1.= "<i>$s</i>";
			}
			elsif ($type{$id} eq 'net') {
				$p1.= "<b>NET:</b> $ip{$id} <b>MASK:</b> $mask{$id}";
				#$p1.= "<i>$s</i>";
			}
			$p1.="</td>\n";
		}
		$p1 .= "</table>";

		$p2="<br><br><b>$L_monitor_periodselect:</b><br>\n";
		$p2.="<br><table width=100% cellpadding=2 cellspacing=0 border=0>";
		$p2.="<tr><td colspan=2><input type=radio name=period value=mon> $L_monitor_ps_mon</td></tr>\n";
		$p2.="<tr><td colspan=2><input type=radio name=period value=week> $L_monitor_ps_week</td></tr>\n";
		$p2.="<tr><td colspan=2><input type=radio name=period value=day> $L_monitor_ps_day</td></tr>\n";
		$p2.="<tr><td colspan=2><input type=radio name=period value=hour checked> $L_monitor_ps_hour</td></tr>\n";
		$p2.="<tr><td colspan=2><input type=radio name=period value=exact> $L_monitor_ps_exact: (dd.mm.yyyy hh:mm)</td></tr>\n";
		$p2.="<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$L_monitor_periodselect_from: <input type=text name=period_from size=40></td>\n";
		$p2.="<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$L_monitor_periodselect_to: <input type=text name=period_to size=40></td></tr>\n";
		$p2.= "</table>";

		$p3="<br><br><b>$L_monitor_detailselect:</b><br>\n";
		$p3.="<br><table width=100% cellpadding=2 cellspacing=0 border=0>";
		$p3.="<tr><td><input type=radio name=detail value=list checked> $L_monitor_ds_list</td></tr>\n";
		$p3.="<tr><td><input type=radio name=detail value=urls> $L_monitor_ds_urls</td></tr>\n";
		$p3.= "</table>";

		$p4 = "<br><input type=submit value=\"$L_monitor_submit\">\n";
	}
	
	$rightdata = "$p1 $p2 $p3 $p4"; 

netams_print();

sub getUnits() {
	netams_send("show config");
	$result=netams_readline();
	$j1=index($result, "unit ");
	$j2=index($result, "storage", $j);
	$result=substr($result, $j1, $j2);
	@s_config=split("\n", $result);
	foreach $s (@s_config) {
		@s_u=split(/\s+/, $s);
		if($s_u[0] ne "unit") {return; }
#               print  "$s <br>";
		$id=$s_u[3];

                $type{$id}=$s_u[1];
                $name{$id}=$s_u[5];
#		if ($s_u[6] eq "ip") { $ip{$id}=$s_u[7]; } else {$ip{$id}=""; }

		$j=6;
		while(defined($s_u[$j])) {
#			print "$id -- $j $s_u[$j] <br>";
			if ($s_u[$j] eq "ip") { $ip{$id}=$s_u[$j+1]; $j=$j+1; }
			if ($s_u[$j] eq "mask") { $mask{$id}=$s_u[$j+1]; $j=$j+1; }
			if ($s_u[$j] eq "parent") { $parent{$id}=$s_u[$j+1]; $j=$j+1; }
                	if ($s_u[$j] eq "password") { $password{$id}=$s_u[$j+1]; $j=$j+1; }
                	if ($s_u[$j] eq "email") { $email{$id}=$s_u[$j+1];  $j=$j+1; }
			if ($s_u[$j] eq "no-local-pass") { $nlp{$id}="on"; }
			if ($s_u[$j] eq "fw-policy") { last; }
			if ($s_u[$j] eq "acct-policy") { last; }
			$j++;
		}
	}
}

