#!/usr/bin/perl -w
#
# $Id: access-script-linux.pl,v 1.1.2.1 2006/04/24 10:39:16 anton Exp $
# Contributed to NeTAMS project by RAMI
# see http://www.netams.com

use DBI;
use strict;

my ($mysql_db, $mysql_host, $mysql_login, $mysql_password, $action, $oid, $why, $firewall, $lan,
    @ip_frag, $i, $j, $found, $ipaddr, $policytable, @netip, @netmask, @parent, @password, @nlp, $s,
    $dbh, $table, @rule, $rule, $rules, $acceptrule, $globalpolicy); my (@ip, $if1, @if2, $proxy, $proxyports);

$mysql_db="netams";
$mysql_host="localhost";
$mysql_login="username";
$mysql_password="password";
#         (      NetAMS'a $policytable="policy";

#   :
#
#  -    #$proxy = "yes"; #  - #$proxyports = "3128,2121"; #    (     ) #$globalpolicy = "BLOCK";

sub getifaces() {
    my $ifaces = `ifconfig | grep Link`;
    my $ifaddr = `ifconfig | grep inet`;
    $ifaces =~ s/\s.*\n/\n/g;
    $ifaddr =~ s/(\w+?:)//g; $ifaddr =~ s/inet//g; #$ifaddr =~ s/\s+.*//o; $ifaddr =~ s/\s+/\n/g;
    my @ifname = split(/\n/, $ifaces);
    my (@if, @if1);
    $j = 0;
    @if = split(/\n/, $ifaddr);
    foreach $ifaddr (@if) {
        ($if1 = $ifaddr) =~ s/\s+/\n/g;
        @if2 = split(/\n/, $if1);
            if ($ifname[$j] ne "lo") {
            $ip[$j][0] = $if2[1]; $ip[$j][1] = $if2[3]; $ip[$j][2] = $ifname[$j];
#               print $ip[$j][0].": ".$ip[$j][1]." - ".$ip[$j][2]."\n";
            }
        $j++;
    }
    return @ip;
}

sub PolicyToTable() {
    $dbh = DBI->connect("DBI:mysql:database=$mysql_db;host=$mysql_host", $mysql_login, $mysql_password) or die $DBI::errstr;
    foreach $table ($dbh->tables()) { if ($table eq "`$policytable`") { my $found = "yes"; return;} }
    if (!defined($found)) {
    $dbh->do("CREATE TABLE $policytable ( oid varchar(10) default NULL, ip varchar(20) default NULL, policy varchar(32) default NULL,
              service varchar(32) default NULL, time int(10) default NULL, PRIMARY KEY (oid)) TYPE=MyISAM;");
    }
    my $time = time;
host=$mysql_host", $mysql_login, $mysql_password) or die $DBI::errstr;
    if ($dbh->do("SELECT * FROM $policytable WHERE oid=$oid") ne "1") {
    $dbh->do("INSERT $policytable (oid, ip, policy, service, time) values ('$oid', '$ipaddr', '$action', '$why','$time')");
    } else {
    $dbh->do("UPDATE $policytable set oid = '$oid', ip = '$ipaddr', policy = '$action', service ='$why', time = $time WHERE oid='$oid'");
    }
    $dbh->disconnect;
}

sub checklan {
    getifaces();
    my (@ipserver, @ipclient, $lan);
    for ($i=0; $i<=@ip-1; $i++) {
        $j=0;
        @ip_frag=split(/\./, $ip[$i][0]);
        foreach my $frag (@ip_frag) { $ipserver[$i][$j] = $frag; $j++; }
    }
    my @ip_frag=split(/\./, $ipaddr);
    $j=0;
        foreach my $frag (@ip_frag) { $ipclient[$j] = $frag; $j++;}
    for ($i=0; $i<=@ip-1; $i++) {
        if ($ipserver[$i][0] eq $ipclient[0] && $ipserver[$i][1] eq $ipclient[1] && $ipserver[$i][2] eq $ipclient[2] && $ipserver[$i][0] ne "" && $ipclient[0] ne "" ) {
        $acceptrule = `/sbin/iptables -vnL | grep $ipaddr`;
        foreach ($acceptrule) {
            if (defined($acceptrule) && $acceptrule ne "") {
            $lan = "$ip[$i][0]/$ip[$i][1]";
            if (!defined($globalpolicy)){
                $rule = "INPUT -s ! $lan -d $ipaddr";
                if (defined($proxy)) {
                    $rule .= " -j ACCEPT\nINPUT -s $lan -d $ipaddr -p tcp -m multiport --sports $proxyports -j ACCEPT\n"        }
                else { $rule .= " -j ACCEPT\n" }
                $rule .= "OUTPUT -d ! $lan -s $ipaddr";
                if (defined($proxy)) { $rule .= " -j ACCEPT\nOUTPUT -d $lan -s $ipaddr -p tcp -m multiport --dports $proxyports -j ACCEPT\n"      }
                else { $rule .= " -j ACCEPT\n" }
            } else {
                $rule .= "$globalpolicy -s ! $lan -d $ipaddr";
                if (defined($proxy)) { $rule .= " -j ACCEPT\n$globalpolicy -s $lan -d $ipaddr -p tcp -m multiport --sports $proxyports -j ACCEPT\n"       }
                else { $rule .= " -j ACCEPT\n" }
                $rule .= "$globalpolicy -d ! $lan -s $ipaddr";
                if (defined($proxy)) { $rule .= " -j ACCEPT\n$globalpolicy -d $lan -s $ipaddr -p tcp -m multiport --dports $proxyports -j ACCEPT\n"       }
                else { $rule .= " -j ACCEPT\n" }
            }
            @rule = split(/\n/, $rule);
            foreach $rules (@rule) {
                if (defined($rules)) { $firewall = `/sbin/iptables -D $rules`; }
            }
            }
        }
            if (`/sbin/iptables -vnL | grep $ipaddr` eq "") {
            $lan = "$ip[$i][0]/$ip[$i][1]";
            if (!defined($globalpolicy)){
                $rule = "INPUT -s ! $lan -d $ipaddr";
                if (defined($proxy)) {
                    $rule .= " -j ACCEPT\nINPUT -s $lan -d $ipaddr -p tcp -m multiport --sports $proxyports -j ACCEPT\n"        }
                else { $rule .= " -j ACCEPT\n" }
                $rule .= "OUTPUT -d ! $lan -s $ipaddr";
                if (defined($proxy)) { $rule .= " -j ACCEPT\nOUTPUT -d $lan -s $ipaddr -p tcp -m multiport --dports $proxyports -j ACCEPT\n"      }
                else { $rule .= " -j ACCEPT\n" }
            } else {
                $rule .= "$globalpolicy -s ! $lan -d $ipaddr";
                if (defined($proxy)) { $rule .= " -j ACCEPT\n$globalpolicy -s $lan -d $ipaddr -p tcp -m multiport --sports $proxyports -j ACCEPT\n"       }
                else { $rule .= " -j ACCEPT\n" }
                $rule .= "$globalpolicy -d ! $lan -s $ipaddr";
                if (defined($proxy)) { $rule .= " -j ACCEPT\n$globalpolicy -d $lan -s $ipaddr -p tcp -m multiport --dports $proxyports -j ACCEPT\n"       }
                else { $rule .= " -j ACCEPT\n" }
            }
            @rule = split(/\n/, $rule);
            return @rule;
            }
        }
    }
}

$action = shift;
$oid = shift;
$ipaddr = shift;
$why = shift;

if (defined($action) && defined($oid) && defined($ipaddr) && defined($why)) {
    if ($action eq "DENY" && $ipaddr ne "0.0.0.0") {
        checklan();
        PolicyToTable();
    } elsif ($action eq "ALLOW" && $ipaddr ne "0.0.0.0") {
        checklan();
        foreach $rules (@rule) { if (defined($rules)) { my $firewall = `iptables -I $rules`;} }
        PolicyToTable();
    }
}


